/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_STUB_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_STUB_HPP_

#include <functional>
#include <sstream>



#include <v1/commonapi/telux/common/CommonDefines.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypes.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesStub.hpp>

#include <v1/commonapi/telux/cv2x/Cv2xRadio.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <unordered_set>
#include <vector>


#include <CommonAPI/Stub.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Cv2xRadio. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class Cv2xRadioStubAdapter
    : public virtual CommonAPI::StubAdapter,
      public virtual Cv2xRadio,
      public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubAdapter {
 public:
    /**
    * Sends a broadcast event for currentCv2xStatus. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) = 0;
    /**
    * Sends a broadcast event for currentCv2xStatusEx. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireCurrentCv2xStatusExEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx) = 0;
    /**
    * Sends a broadcast event for currentL2Addr. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireCurrentL2AddrEvent(const uint32_t &_newL2Addr) = 0;
    /**
    * Sends a broadcast event for currentSpsOffset. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireCurrentSpsOffsetEvent(const int32_t &_spsId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails &_details) = 0;
    /**
    * Sends a broadcast event for currentCapabilities. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireCurrentCapabilitiesEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities) = 0;
    /**
    * Sends a broadcast event for macAddrClone. Should not be called directly.
    * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
    */
    virtual void fireMacAddrCloneEvent(const bool &_detected) = 0;


    virtual void deactivateManagedInstances() = 0;


protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */

};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Cv2xRadio.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class Cv2xRadioStubRemoteEvent
: public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubRemoteEvent
{
public:
    virtual ~Cv2xRadioStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Cv2xRadio to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class Cv2xRadioStub
    : public virtual CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>,
      public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStub
{
public:
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, uint32_t _subscriptionId)> createRxSubscriptionReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus _status)> getServiceStatusReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error)> enableRxMetaDataReportReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, uint32_t _txSpsFlowId, uint32_t _txEventFlowId, ::v1::commonapi::telux::common::CommonDefines::ErrorCode _spsError, ::v1::commonapi::telux::common::CommonDefines::ErrorCode _eventError)> createTxSpsFlowReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, uint32_t _txEventFlowId)> createTxEventFlowReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error)> closeRxSubscriptionReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error)> closeTxFlowReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error)> changeSpsFlowInfoReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo)> requestSpsFlowInfoReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error)> changeEventFlowInfoReply_t;
    typedef std::function<void (::v1::commonapi::telux::common::CommonDefines::ErrorCode _error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities _capabilities)> requestCapabilityReply_t;

    virtual ~Cv2xRadioStub() {}
    void lockInterfaceVersionAttribute(bool _lockAccess) { static_cast<void>(_lockAccess); }
    bool hasElement(const uint32_t _id) const {
        return (_id < 17);
    }
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method createRxSubscription.
    virtual void createRxSubscription(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint16_t _port, std::vector< uint32_t > _idList, createRxSubscriptionReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method getServiceStatus.
    virtual void getServiceStatus(const std::shared_ptr<CommonAPI::ClientId> _client, getServiceStatusReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method enableRxMetaDataReport.
    virtual void enableRxMetaDataReport(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, bool _enable, std::vector< uint32_t > _idList, enableRxMetaDataReportReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method createTxSpsFlow.
    virtual void createTxSpsFlow(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipType, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, uint16_t _spsSrcPort, bool _eventSrcPortValid, uint16_t _eventSrcPort, createTxSpsFlowReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method createTxEventFlow.
    virtual void createTxEventFlow(const std::shared_ptr<CommonAPI::ClientId> _client, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::TrafficIpType _ipTyp, uint32_t _serviceId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _flowInfo, uint16_t _eventSrcPort, createTxEventFlowReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method closeRxSubscription.
    virtual void closeRxSubscription(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _subscriptionId, closeRxSubscriptionReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method closeTxFlow.
    virtual void closeTxFlow(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, closeTxFlowReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method changeSpsFlowInfo.
    virtual void changeSpsFlowInfo(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::SpsFlowInfo _spsInfo, changeSpsFlowInfoReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method requestSpsFlowInfo.
    virtual void requestSpsFlowInfo(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, requestSpsFlowInfoReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method changeEventFlowInfo.
    virtual void changeEventFlowInfo(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _txFlowId, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::EventFlowInfo _eventInfo, changeEventFlowInfoReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method requestCapability.
    virtual void requestCapability(const std::shared_ptr<CommonAPI::ClientId> _client, requestCapabilityReply_t _reply) = 0;
    /// Sends a broadcast event for currentCv2xStatus.
    virtual void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCurrentCv2xStatusEvent(_status);
    }
    /// Sends a broadcast event for currentCv2xStatusEx.
    virtual void fireCurrentCv2xStatusExEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCurrentCv2xStatusExEvent(_statusEx);
    }
    /// Sends a broadcast event for currentL2Addr.
    virtual void fireCurrentL2AddrEvent(const uint32_t &_newL2Addr) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCurrentL2AddrEvent(_newL2Addr);
    }
    /// Sends a broadcast event for currentSpsOffset.
    virtual void fireCurrentSpsOffsetEvent(const int32_t &_spsId, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::MacDetails &_details) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCurrentSpsOffsetEvent(_spsId, _details);
    }
    /// Sends a broadcast event for currentCapabilities.
    virtual void fireCurrentCapabilitiesEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xRadioCapabilities &_capabilities) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCurrentCapabilitiesEvent(_capabilities);
    }
    /// Sends a broadcast event for macAddrClone.
    virtual void fireMacAddrCloneEvent(const bool &_detected) {
        auto stubAdapter = CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMacAddrCloneEvent(_detected);
    }


    using CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<Cv2xRadioStubAdapter, Cv2xRadioStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef Cv2xRadioStubRemoteEvent RemoteEventType;
    typedef Cv2xRadio StubInterface;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_STUB_HPP_
